
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  

 
 require 'sketchup.rb'

 def create_board
   model=Sketchup.active_model
   #apparently no need to use.start_operation
   # and commit_operation

   # lets purge unused component definitions
   if Sketchup.version_number >6000276
    definitions=model.definitions
    definitions.purge_unused
   end#if

   # use instance variables as defaults, they are remembered
   #  ! is not
   if !@val1 then @val1="R/G" end
   if !@val2 then @val2=0.75.inch end
   if !@val3 then @val3=3.5.inch end
   if !@val4 then @val4=10.inch end
   if !@val5 then @val5="Comp Name" end

   prompts = ["Lgth/Width Axis's","Thickness", "Width","Length","Name"]
   defaults= [@val1,@val2,@val3,@val4,@val5]
   choices = ["R/G|R/B|G/R|G/B|B/R|B/G","","","","",""]
   
   results = inputbox prompts, defaults, choices, "Input Board"
   
   return if not results  # user canceled
  
   @val1=results[0]
   @val2=results[1]
   @val3=results[2]
   @val4=results[3]
   @val5=results[4]

   #Create component definition
   new_comp_def=model.definitions.add("Board")
   #create array
   points=Array.new

   if @val1=="R/G"
    points[0]=[0, 0, 0]
    points[1]=[@val4,0,0]
    points[2]=[@val4,@val3,0]
    points[3]=[0,@val3,0]
    height=@val2
   elsif @val1=="R/B"
    points[0]=[0, 0, 0]
    points[1]=[@val4,0,0]
    points[2]=[@val4,@val2,0]
    points[3]=[0,@val2,0]
    height=@val3
   elsif @val1=="G/R"
    points[0]=[0, 0, 0]
    points[1]=[@val3,0,0]
    points[2]=[@val3,@val4,0]
    points[3]=[0,@val4,0]
    height=@val2
   elsif @val1=="G/B"
    points[0]=[0, 0, 0]
    points[1]=[@val2,0,0]
    points[2]=[@val2,@val4,0]
    points[3]=[0,@val4,0]
    height=@val3
   elsif @val1=="B/R"
    points[0]=[0, 0, 0]
    points[1]=[@val3,0,0]
    points[2]=[@val3,@val2,0]
    points[3]=[0,@val2,0]
    height=@val4
   else
    points[0]=[0, 0, 0]
    points[1]=[@val2,0,0]
    points[2]=[@val2,@val3,0]
    points[3]=[0,@val3,0]
    height=@val4
   end


   #add the face to the component
   face=new_comp_def.entities.add_face(points)
   #if blue face is pointing up, reverse it
   face.reverse! if(face.normal.z<0)
   
   name=new_comp_def.name=@val5

   #pull up the height
   face.pushpull(height)
   
   #inserts component at left click in model
   status=model.place_component(new_comp_def)
 
   #THIS IS ONE WAY TO CREATE A COMPONENT---------------------------------
   #trans=Geom::Transformation.new
   #Sketchup.active_model.active_entities.add_instance(new_comp_def,trans)
   #----------------------------------------------------------------------

 end
 

 #Resize a rectalinear component, only has meaning for rectalinear component
 # rejects multiple parallel faces etc.
 class ResizeBoard #*****************************************************************

  def initialize
   @entity=nil
   @ss=nil
  end
  
  #is called when first activated
  def activate
 
   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     actonfaces
     self.reset(nil)
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
   
  end

  #is called if tool is deactivated because a different tool is selected
  #not necessary I guess here
  #def deactivate(view)
  # view.invalidate if @drawn
  #end

  #onCancel is called when user hits escape
  def onCancel(flag, view)
   self.reset(view)
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
       actonfaces
      else
       UI.messagebox "Selection invalid"
      end
     end
    end
  end
  
  def actonfaces  #collect faces, gets valid rectilinear faces and distance
                  #input new distance and edit component
   pface1=nil;dist1=10000
   pface2=nil;dist2=10000
   pface3=nil;dist3=10000
   #collectentities
   componentdefinition=@entity.definition
   allent=componentdefinition.entities
   #collect face entities
   faceent=[]
   faceentdid=[]
   allent.each do |ent|
    if ent.typename=="Face"
     faceent << ent
     faceentdid <<0
    end
   end
   
   num=0    #of valid distances between faces
   j=0
   faceent.each do |ent|
    if faceentdid[j]==0
     pface,dist = getparallelface(ent,faceent)
     cnorm=ent.normal
     k=0
     faceent.each do |lent|
       if cnorm.parallel?(lent.normal)
        faceentdid[k]=1
       end
      k=k+1
     end
    else
     pface=nil
     dist=0
    end    
    
    if dist>0 then 
     num=num+1
     if num==1 then pface1=pface;dist1=dist end
     if num==2 then pface2=pface;dist2=dist end
     if num==3 then pface3=pface;dist3=dist end
    end  
    j=j+1
   end 

   if (dist1+dist2+dist3)==30000 then
    @ss.clear
    return
   end

   #sort for input box
   if dist1>dist2 then pface1,pface2=pface2,pface1;dist1,dist2=dist2,dist1 end
   if dist2>dist3 then pface2,pface3=pface3,pface2;dist2,dist3=dist3,dist2 end
   if dist1>dist2 then pface1,pface2=pface2,pface1;dist1,dist2=dist2,dist1 end
   prompts = ["1st Dim","2nd Dim", "3rd Dim"]
   defaults= [dist1.inch,dist2.inch,dist3.inch]
   
   results = inputbox prompts, defaults, "Resize Board"
   
   if !results then   #user canceled
    @ss.clear
    return
   end
   
   #push pull
   Sketchup.active_model.start_operation "undo"
   if (dist1<9999) and (dist1>0.01)
    zd= results[0]-dist1
    if zd.abs>0.01 then
      pface1.pushpull zd
    end
   end
   if (dist2<9999) and (dist2>0.01)
    zd= results[1]-dist2
    if zd.abs>0.01 then
      pface2.pushpull zd
    end
   end
   if (dist3<9999) and (dist3>0.01)
    zd= results[2]-dist3
    if zd.abs>0.01 then
      pface3.pushpull zd
    end
   end
   @ss.clear
   Sketchup.active_model.commit_operation
  end        #end actonfaces
  
  #get farthest parallel face and distance from face to facent[]
  #we subtract the actual normal vectors to eliminate origin problems
  #and get the distance between parallel planes
  def getparallelface(face,faceent)
   dist=0
   pface=nil
   num=0
   cnorm=face.normal
   cplane=face.plane
   zpt=Geom::Point3d.new 0,0,0
   ept=zpt.project_to_plane cplane
   tnorm=Geom::Vector3d.new ept.x,ept.y,ept.z #get true normal vector
  
   faceent.each do |ent|
    if (cnorm.parallel?(ent.normal))  
     eplane=ent.plane
     enept=zpt.project_to_plane eplane
     enorm=Geom::Vector3d.new enept.x,enept.y,enept.z #get true normal vector
     dnorm=enorm-tnorm                                #get difference vector
     dd=dnorm.length.abs
     if dd>dist
      dist=dd
      pface=ent
     end
     num=num+1
    end
   end
   if !(num==2) then pface=nil;dist=0 end   #only 2 parallel faces make sense
   return pface,dist
  end
 
  
  #reset to start over again
  def reset(view)
   @status=1
   @drawn=false
   @entity=nil
   Sketchup::set_status_text "Select component",SB_PROMPT
  end

 end #end class ResizeBoard*************************************************************

 #function acts as short cut for selecting tool
 def resizeboard
   Sketchup.active_model.select_tool ResizeBoard.new 
 end


 #drills hole in component face
 class DrillTool #*****************************************************************
  #@status=0 start,  =1 select component, =2 component selected get point
   @@depth=nil  #make class variables persist
   @@diam=nil
   @@nseg=nil

  def initialize
   @entity=nil
   @ss=nil
   @status=0
   @inpt=nil
   @tinpt=nil
   @ip=nil
   if !@@depth then @@depth=99.inch end                 #defaults 
   if !@@diam then @@diam=0.375.inch end
   if !@@nseg then @@nseg=8 end
  end

  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     Sketchup::set_status_text "Select point on face in component",SB_PROMPT
     @status=2
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
  end

  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

  #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select component",SB_PROMPT
  end

  #cruise for a point in component
  def onMouseMove(flags, x, y, view)
   if @status==2
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
   end
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1  #select component*************
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
        Sketchup::set_status_text "Select point on face in component",SB_PROMPT
        @status=2
      else
       UI.messagebox "Selection invalid"
      end
     end
    elsif @status==2     #get valid center point for circle
     @ip.pick view,x,y
     oops=1
     if(@ip.valid?)
      if(@ip.face)then
       if (@entity.definition==@ip.face.parent) 
         if ((!@ip.vertex) and (!@ip.edge) and (@ip.depth>0))
           Sketchup.active_model.start_operation "undo"
           oops=0
           #collectentities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            #collect face entities
            faceent=[]
            allent.each do |ent|
             if ent.typename=="Face"
              faceent << ent
             end
            end

           tran=@entity.transformation.inverse
           norm=@ip.face.normal
           plane=@ip.face.plane
           pos=@ip.position.transform! tran    #oddly pos yields world coord to transform 
                                               #to inverse of component transformation
           line = [pos,norm]                   #component space
           
           num=0                               #get perp to this face - dist to other face
           dist=10000
           faceent.each do |ent|
            eplane=ent.plane
             if !(eplane==plane)
              npt=Geom.intersect_line_plane(line,eplane)
              if !(npt==nil)                   #npt is perp point in someother plane
               orig=ent.vertices[0].position
               x,y,z=ent.normal.axes
               localt=Geom::Transformation.axes(orig,x,y,z).invert!
               loop=ent.outer_loop
               tnpt=npt.transform(localt)
               looppts=loop.vertices.collect{|v| v.position.transform(localt)}
               bounds=false
               youin=Geom.point_in_polygon_2D(tnpt,looppts,bounds)
               if youin
                 dd=((pos.x-npt.x)**2+(pos.y-npt.y)**2+(pos.z-npt.z)**2)**0.5
                 if ((dd>=0.01) and (dd<dist)) then dist=dd end
               end
              end
             end
           end                                #got perpdist to other face
		   
			prompts = ["Diameter","Depth", "Number segments"]
			defaults= [@@diam.inch,@@depth.inch,@@nseg]
			results = inputbox prompts, defaults, "Drill Board"
			if !results then return end  #user canceled
			@@diam=results[0]
			@@depth=results[1]
			@@nseg=results[2]
			if @@diam<0.1 then return end
			if @@depth==0 then return end
			if @@nseg<4 then @nseg=4 end
			      
           r=0.5*@@diam    
           codef=@entity.definition                           
           circ=codef.entities.add_circle(pos,norm,r,@@nseg)
           l=codef.entities.length-1
           cface=codef.entities[l]  
                                         #apparently positive pushpull is always out?
           if (@@depth>dist)
		    h=-1*dist
           else
		    h=-1*@@depth
           end		   
           cface.pushpull h
           Sketchup.active_model.commit_operation
         end
       end
      end
     end
     if oops==1
      UI.messagebox "Invalid point"
     end
    end
  end  

  #draw is called when we want to display then point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

  
 end #end Class DrillTool************************************

 #function acts as short cut for selecting tool
 def drillboard
   Sketchup.active_model.select_tool DrillTool.new
 end


#creates dado in component face
 class DadoTool #*****************************************************************
   #@status=0 start,  =1 select component, =2 first edge, =3 second edge
   
   @@todist=nil   #make class variables persist
   @@toedge=nil
   @@depth=nil  
   @@width=nil
   

  def initialize
   @entity=nil
   @ss=nil
   @status=0
   @inpt=nil
   @tinpt=nil
   @ip=nil
   if !@@todist then @@todist=0.25.inch end           #defaults
   if !@@toedge then @@toedge="To" end
   if !@@depth then @@depth=0.25.inch end                  
   if !@@width then @@width=0.75.inch end
  end

  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
     @status=2
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
  end
  
  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

 #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select component",SB_PROMPT
  end

   #cruise for a point in component
  def onMouseMove(flags, x, y, view)
   if (@status==2 or @status==3)
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
   end
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1  #select component*************
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
        Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
        @status=2
      else
       UI.messagebox "Selection invalid"
      end
     end
    elsif @status==2
	 @ip.pick view,x,y
	 oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and (@ip.depth>0))
		 oops=0
		 @edge1=@ip.edge
	     Sketchup::set_status_text "Select TO edge in component",SB_PROMPT
         @status=3
		end 
	   end	
	  end 
	 end
	 if oops==1
	  @status=2
	  @edge1=nil
	  UI.messagebox "Invalid point"
	 end
	elsif @status==3
	 @ip.pick view,x,y
     oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and !(@ip.edge==@edge1) and (@ip.depth>0))
		 oops=0
		 Sketchup.active_model.start_operation "undo"
		 @edge2=@ip.edge
		 #collectentities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            #collect face entities
            faceent=[]
            allent.each do |ent|
             if ent.typename=="Face"
              faceent << ent
             end
            end
		    #find face that has edges 1 and 2
			face=@edge1.common_face @edge2
			if (face==nil)                    #get valid face
		     oops=1
			else                              #got valid face######################
			   #get points in local coord system for face
			   #xaxis parallel to @edge1
			   orig=@edge1.start
               x,y,z=face.normal.axes
			   #get vector parallel to @edge1
			   p1=@edge1.start.position
			   p2=@edge1.end.position
			   ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
			   xx=ar.normalize
			   yy=z.cross xx
               localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
			   backt=Geom::Transformation.axes(orig,xx,yy,z)
			   edges=face.outer_loop.edges
			   eind=edges.index(@edge1)
			   
			   prompts = ["To Distance","To Edge", "Width","Depth"]
               defaults= [@@todist,@@toedge,@@width,@@depth]
               choices = ["","To|Center|Over","",""]
   
               results = inputbox prompts, defaults, choices, "Dado Board"
               #return if not results
			   if not results  #user cancel
			    @status=2
			    @edge1=nil
			    @edge2=nil
			    return
			   end
  
               @@todist=results[0]
               @@toedge=results[1]
               @@width=results[2]
               @@depth=results[3]
			   
			   if @@toedge=="To"
			    ofstov=@@todist+@@width
			   elsif @@toedge=="Center"
			    ofstov=@@todist+0.5*@@width
			   else 
			    ofstov=@@todist
			   end
			   ofstto=ofstov-@@width
			   if ofstto<=0.001 then ofstto=0 end
			   
               #looppts=loop.vertices.collect{|v| v.position.transform(localt)}
			   p3=@edge2.start.position.transform(localt)
			   en=eind-edges.length+1;i=eind-1
			   dir=p3.y<=>0
			   ofstov=dir*ofstov
			   ofstto=dir*ofstto
			   frstov=0
			   frstto=0
			   while i>=en
			    p1=edges[i].start.position.transform(localt)
                p2=edges[i].end.position.transform(localt)
                p1y=p1.y;p2y=p2.y
				if p1y>p2y then p1y,p2y=p2y,p1y end
                if (p1y..p2y)===ofstov
				 x=p1.x+(ofstov-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				 if frstov==0 then x1=x;frstov=1 end
				 x2=x
                end	
				if ofstto>0.001
				 if (p1y..p2y)===ofstto
				  x=p1.x+(ofstto-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				  if frstto==0 then x4=x;frstto=1 end
				  x3=x
				 end
				end
			    i-=1
			   end
			    
			   pt1=Geom::Point3d.new(x1,ofstov,0)
			   pt2=Geom::Point3d.new(x2,ofstov,0)
			   if ofstto>0.001
			    pt4=Geom::Point3d.new(x4,ofstto,0)
			    pt3=Geom::Point3d.new(x3,ofstto,0)
			   else
			    pt4=Geom::Point3d.new(x1,0,0)
			    pt3=Geom::Point3d.new(x2,0,0)
			   end
			   po1=pt1.transform(backt)
			   po4=pt4.transform(backt)
			   po2=pt2.transform(backt)
			   po3=pt3.transform(backt)
			   codef=@entity.definition
			   cface=codef.entities.add_face po1,po2,po3,po4

		     h=-1*@@depth	   
             cface.pushpull h
             Sketchup.active_model.commit_operation
			  
		     Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
             @status=2
		    end                                ####################################
		end 
	   end	
	  end 
	 end
     if oops==1
	  @status=3
	  @edge2=nil
	  UI.messagebox "Invalid point"
	 end	  
    end
  end  

  #draw is called when we want to display then point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

  
 end #end Class DadoTool*********************************************

 #function acts as short cut for selecting tool
 def dadoboard
   Sketchup.active_model.select_tool DadoTool.new
 end
 
 #add to Draw menu after separator

 if( not file_loaded?("woodwrk.rb"))
  #add_separator_to_menu("Draw")
  UI.menu("Draw").add_separator
  UI.menu("Draw").add_item("Create Board"){create_board}
  UI.menu("Draw").add_item("Resize Board"){resizeboard}
  UI.menu("Draw").add_item("Drill Board"){drillboard}
  UI.menu("Draw").add_item("Dado Board"){dadoboard}
 end

 file_loaded("woodwrk.rb")
#--------------------------